<template>
  <form novalidate class="md-layout md-gutter md-alignment-top-center">
    <md-card class="md-layout-item md-size-33 md-small-size-50 md-xsmall-size-100">
      <md-card-header>
        <div class="md-title">Login</div>
      </md-card-header>

      <md-card-content>
        <md-field v-if="!passwordless">
          <label for="email">Email</label>
          <md-input
            type="email"
            name="email"
            id="email"
            autocomplete="email"
            v-model="email"
            :disabled="sending"
          />
        </md-field>
        <md-field v-if="!passwordless">
          <label for="name">Password</label>
          <md-input
            type="password"
            name="password"
            id="password"
            v-model="password"
            :disabled="sending"
          />
        </md-field>
        <md-checkbox v-model="passwordless">Passwordless</md-checkbox>
        <md-checkbox v-model="transports">transports</md-checkbox>
      </md-card-content>

      <md-progress-bar md-mode="indeterminate" v-if="sending" />

      <md-card-actions>
        <md-button type="submit" class="md-primary" :disabled="sending" v-on:click="login()">Login</md-button>
      </md-card-actions>
    </md-card>
    <Communication :path="path" :message="message" :detail="detail" :working="working" @next="login()" />

    <md-snackbar :md-active.sync="loggedIn">You have been logged in!</md-snackbar>
  </form>
</template>

<script>
import { solveLoginChallenge } from "@webauthn/client";
import Communication from "@/components/Communication.vue";
import { mutations } from "../store";
import { extractLoginCredential } from "@/utils";
import { store } from "../store";
import { CommunicationDirection } from './communication-direction';

export default {
  name: "Login",
  props: {
    msg: String
  },
  components: {
    Communication
  },
  computed: {
    debug: function() {
      return store.debug;
    }
  },
  methods: {
    steps: function() {
      return [this.login_s0, this.login_s1, this.login_s2, this.login_s3, this.login_s4, this.login_s5];
    },
    login: async function() {
      this.working = true;
      if (this.debug) {
        await this.steps()[this.step]();
      } else {
        for (let step in [0, 1, 2, 3, 4, 5]) {
          await this.steps()[step]();
        }
      }
      this.working = false;
    },
    login_s0: async function() {
      this.sending = true;
      // ******************
      // Request challenge
      // ******************
      this.path = CommunicationDirection.BROWSER_2_SERVER;
      this.message = this.passwordless ? {} : { email: this.email, password: this.password };
      this.step = 1;
    },
    login_s1: async function() {
      this.sending = true;
      // **************************
      // Get challenge from Backend
      // **************************
      const loginRequest = await fetch(
        process.env.VUE_APP_API + "/authn/init",
        {
          method: "POST",
          headers: {
            "content-type": "application/json"
          },
          body: JSON.stringify(this.passwordless ? {} : { email: this.email, password: this.password })
        }
      ).then(response => response.json());
      this.path = CommunicationDirection.SERVER_2_BROWSER;
      this.message = loginRequest;
      this.loginRequest = loginRequest;
      this.step = 2;
    },
    login_s2: async function() {
      let challenge;
      if (!this.passwordless) {
        challenge = {
          challenge: this.loginRequest.challenge,
          allowCredentials: [
            {
              type: "public-key",
              id: this.loginRequest.keyId,
              ... (this.transports ? {transports: ['nfc']} : {})
            }
          ]
        };
      } else {
        challenge = {
          challenge: this.loginRequest.challenge,
          rpId: window.location.hostname,
          userVerification: "preferred",
          allowCredentials: []
        };
      }

      this.path = CommunicationDirection.BROWSER_2_KEY;
      this.message = challenge;
      this.step = 3;
      this.challenge = challenge;
    },
    login_s3: async function() {
      // ****************************
      // Get credentials from Browser
      // ****************************
      const credentials = await solveLoginChallenge(this.challenge);
      this.path = CommunicationDirection.KEY_2_BROWSER;
      this.message = credentials;
      this.detail = extractLoginCredential(credentials);
      this.step = 4;
      this.credentials = credentials;
    },
    login_s4: async function() {
      // ****************************
      // Send credentials to Server
      // ****************************
      this.path = CommunicationDirection.BROWSER_2_SERVER;
      this.message = {... this.message};
      this.detail = undefined;
      this.step = 5;
    },
    login_s5: async function() {
      // ***************************
      // Send credentials to Backend
      // ***************************
      const result = await fetch(process.env.VUE_APP_API + "/authn", {
        method: "POST",
        headers: {
          "content-type": "application/json"
        },
        body: JSON.stringify(this.credentials)
      }).then(response => response.json());

      if (result.loggedIn) {
        this.loggedIn = result.loggedIn;
        mutations.login(result.name);
      }
      this.sending = false;
      this.path = CommunicationDirection.SERVER_2_BROWSER;
      this.message = result;
      this.step = 0;
    }
  },
  data: () => {
    return {
      email: "arnaud.locquet@benefiz.fr",
      password: "s3cur3d",
      passwordless: false,
      sending: false,
      working: false,
      loggedIn: false,
      path: [],
      message: {},
      detail: undefined,
      step: 0,
      loginRequest: {},
      challenge: {},
      credentials: {},
      transports: false
    };
  },
  errorCaptured(err) {
    console.error(err);
    this.message = { error: err.message };
    this.sending = false;
    this.working = false;
    this.detail = undefined;
    this.step = 0;
  }
};
</script>

<!-- Add "scoped"  attribute to limit CSS to this component only -->
<style scoped>
.md-layout {
  padding-top: 50px;
}
</style>
